#include <stdio.h>
#include <stdlib.h>

//imamo niz elemenata, i treba da nadjemo odrdjeni 
//element ili INDEKS odrdjenog elementa koji zadjovoljava 
//odredjeni uslov

void greska(char *s)
{
	printf("Greska: %s\n", s);
	exit(EXIT_FAILURE);
}

int binarna_pretraga_r(int *a, int n, int x, int l, int d)
{
	if(l > d)
		return -1;
	
	int s = (l + d) / 2;
	if(a[s] == x)
		return s;
	else if(x < a[s])
		return binarna_pretraga_r(a, n, x, l, s-1);
	else
		return binarna_pretraga_r(a, n, x, s+1, d);
}

int binarna_pretraga(int *a, int n, int x)
{	
	//pretraga polovljenjem
	//svaki put niz delimo na 2, i gledamo da li da
	//trazimo u levoj polovini ili desnoj polovini
	//slozenost log(n)
	
	int l, d;
	l = 0; 
	d = n-1;
	
	while(l <= d)
	{
		int s = (l + d) / 2;
		if(a[s] == x)
			return s;
		else if(x < a[s])
			d = s - 1;
		else
			l = s + 1;
	}
	return -1;
}

int main()
{
	int n, x, *a, i;
	int index;
	
	scanf("%d", &n);
	scanf("%d", &x);
	
	a = malloc(n * sizeof(int));
	if(a == NULL)
		greska("alokacija");
	
	for(i = 0; i < n; i++)
		scanf("%d", &a[i]);

	printf("iter: %d\n", binarna_pretraga(a, n, x));
	printf("rek: %d\n", binarna_pretraga_r(a, n, x, 0, n-1));
	free(a);
}